#ifndef MAILDIR_TYPES_H

#define MAILDIR_TYPES_H

#include <limits.h>
#include <sys/types.h>
#include <unistd.h>
#include "chash.h"
#include "carray.h"

#define LIBETPAN_MAILDIR

enum {
  MAILDIR_NO_ERROR = 0,
  MAILDIR_ERROR_CREATE,
  MAILDIR_ERROR_DIRECTORY,
  MAILDIR_ERROR_MEMORY,
  MAILDIR_ERROR_FILE,
  MAILDIR_ERROR_NOT_FOUND,
};

#define MAILDIR_FLAG_NEW      (1 << 0)
#define MAILDIR_FLAG_SEEN     (1 << 1)
#define MAILDIR_FLAG_REPLIED  (1 << 2)
#define MAILDIR_FLAG_FLAGGED  (1 << 3)
#define MAILDIR_FLAG_TRASHED  (1 << 4)

struct maildir_msg {
  char * uid;
  char * filename;
  int flags;
};

/*
  work around for missing #define HOST_NAME_MAX in Linux
*/

#ifndef HOST_NAME_MAX
#define HOST_NAME_MAX 255
#endif

struct maildir {
  pid_t pid;
  char hostname[HOST_NAME_MAX];
  char path[PATH_MAX];
  uint32_t counter;
  time_t mtime_new;
  time_t mtime_cur;
  carray * msg_list;
  chash * msg_hash;
};

#endif
